#!/usr/bin/perl
#著作権はヒナギク（http://daisykatsura.dip.jp/）にあります。
#著作権表示は削除しないで下さい。
#改造・再配布はご自由に行っていただいて構いません。
#一行目のPerlパスはプロバイダの設定に合わせて下さい。
#スクリプト設置例
# public_html
# |--cgi-bin
#      |--bbs.cgi(755 or 705)
#      |--bbslog.cgi(666 or 606)
#      |--code_log.cgi (666 or 606)…(使用済みのチェックコード保存用ファイル)…空のままアップロード
#      |--himicode.cgi (755 or 705)…(画像コード生成CGI)（※要　初期設定）
#      |--normal.pl (755 or 705)…(himicode.cgiで使用する画像ライブラリ)
#      |--himiko.cgi (666 or 606)…(発行済のチェックコード保存用ファイル)…空のままアップロード
#      |--trip_name.cgi(666 or 606)…(トリップつきネームを保存するファイル)…空のままアップロード
#      |--jcode.pl(644 or 604)_(デコード用ファイル)
#
#設定箇所ここから
require "./jcode.pl";	#これ重要！

$script = "./bbs.cgi";	#本体ファイル名

$logfile = "./log.cgi";	#投稿データを保存するファイル

$lockfile = "./bbs.lock";	#ロックファイルの名前を指定(自分で作る必要無し)　　http://〜で指定してはダメですよ

$agent = "$ENV{'HTTP_USER_AGENT'}";	#ユーザーエージェント

$password = "7m26bdn";	#マスターパスワード

$hostname = "0";	#ホスト名表示なら1

$proxy = "0";	#プロキシを規制する場合は1

$kiji = "5";	#記事の表示件数

$himicode_ck = 1;	#ひみこーどチェックを使用する(0:no 1:yes)

$himicode = './himicode.cgi';	#ひみこーどチェックを使う場合、画像投稿コード生成用CGIファイルの名前を指定。

$himicode_log = "./himiko.cgi";	#ひみこーどチェックを使う場合、発行済みチェックコードを保存するファイルの名前を指定。

$codefile = "./code_log.cgi";	#使用済みチェックコードを保存するファイルの名前を指定。

$code_logmax = 200;	#使用済みチェックコードを保存する最大件数。ひみこーどの保存件数と同じで良いと思います

$tripfile = './trip_name.cgi';	#トリップ付きの名前を保存するファイルの名前を指定

$trip_logmax = 200;	#トリップ付きの名前を保存する最大件数。使われていないものから順に削除されていきます。

#タグ許可(yes,no)
$tag = 'yes';	

#デンジャラ〜なタグ(タグ許可をyesにした時に禁止にするタグ)
@errtag = ('table','meta','form','!--','embed','html','body','tr','td','th','style','script','img','plaintext','xmp');

#サクセスを拒否するIPアドレス（ホスト名）
@hosts = ('223.144.21.46.justquaconnect.com','14.140.93.99.static-mumbai.vsnl.net.in','p3236-ipbf309koufu.yamanashi.ocn.ne.jp');

#ヘッダー広告（広告が手動挿入の場合、EOM間へ記入。入れない場合は記入しない）
$header  = <<"EOM";

EOM

#フッター広告（広告が手動挿入の場合、EOM間へ記入。入れない場合は記入しない）
$footer = <<"EOM";

EOM

#↓訪問者用アイコンとアイコンの名前の指定。$icon_gif[3]...[10]のように適当に増やして下さいね。
$icon_gif[0] = './icon/nasi.gif' ;              $iconnm[0] = '無し' ;
$icon_gif_w[0] = 0 ; $icon_gif_h[0] = 0 ;
$icon_gif[1] = './icon/ayasakihayate.gif' ;              $iconnm[1] = '綾崎ハヤテ' ;
$icon_gif_w[1] = 0 ; $icon_gif_h[1] = 40 ;


#アイコン一覧を表示する際、１行にアイコンを何個表示します？
$icon_line					= 3 ;	#←の場合、３個表示したら改行するって事です。
#設定箇所ここまで

&decode;
if($FORM{'action'} eq "regist"){&regist;}
if($FORM{'action'} eq "resform"){&resform;}
if($FORM{'action'} eq "resregist"){&resregist;}
if($FORM{'action'} eq "view"){&view;}
if($FORM{'action'} eq "icondisp"){&icondisp;}
if($FORM{'action'} eq "delete"){&delete;}
&header;
&body;
&footer;

#デコード
sub decode {
	if ($ENV{'REQUEST_METHOD'} eq "POST") {
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	} else { $buffer = $ENV{'QUERY_STRING'}; }
	@pairs = split(/&/,$buffer);
	foreach $pair (@pairs) {
		($name, $value) = split(/=/, $pair);
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$value =~ s/>>/&gt;&gt;/g;
		$value =~ s/\r\n|\r|\n/<br>/g;
		$value =~ s/,/&#44;/g;
		$buffer =~ tr/+/ /;
		$buffer =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		&jcode'convert( *value, 'sjis' );
		$FORM{$name} .= $value;
	}

}

sub header {
print "Pragma: no-cache\n";
print "Cache-Control: no-cache\n";
print "Expires: Thu, 01 Dec 1994 16:00:00 GMT\n";
print "Content-type: text/html\n\n";
print <<"EOM";
<html>
<head>
<meta name="robots" content="none">
<meta http-equiv="Pragma" content="no-cache">
<meta http-equiv="Cache-Control" content="no-cache">
<meta http-equiv="Expires" content="Thu, 01 Dec 1994 16:00:00 GMT">
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>BBS</title>
</head>
<body background="" text="#000000" link="blue" alink="purple" vlink="purple">
$header
EOM
}

sub body {
	print "<a href=\"../\" target=\"_top\">TOP</a>&nbsp;<a href=\"$script\">リロード</a><br>\n";
	print "<p align=\"center\"><font size=\"5\">BBS</font></p>\n";
	print <<"EOM";

EOM
	#ユーザエージェント判別
	#ケータイ表示
	if($agent =~ /UP.Browser|DoCoMo|J-PHONE|Vodafone|SoftBank/){
print <<"EOM";
<form action="$script" method="post">
<input type="hidden" name="action" value="regist">
名前↓<br>
EOM
		print "<input type=\"text\" name=\"name\" value=\"";
		foreach (split(/;/, $ENV{'HTTP_COOKIE'})) {
			($name, $value) = split(/=/);
			$name =~ s/\s//g;
			$value =~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("C", hex($1))/eg;
			$cookie{$name} = $value;
		}
		print "$cookie{'name'}";
		print "\"><br>\n";
print <<"EOM";
タイトル↓<br>
<INPUT TYPE=TEXT NAME="subject" value="$subject"><br>
ホームページ↓<br>
<input type="text" name="hp" value="$hp"><br>
メール↓<br>
<input type="text" name="mail" value="$mail"><br>
コメント↓<br>
<textarea name="comment">$comment</textarea><br>
$cerror<br>
<select name="icon">
EOM
		$i = 0 ;
		for ( @iconnm ) {
			if ( $i == $c_icon )	{	$dmy = "selected";	}	else	{	$dmy = "" ;	} 
			print "<option value=$i $dmy>$iconnm[$i]\n";
			$i++ ;
		}
		print "</select>\n";
		print "<a href=\"$script?action=icondisp\">アイコン一覧</a><br>\n";
		print "パスワード↓<br><input type=\"password\" name=\"pass\"><br>";
		#ひみこーどここから
		$limit_time = time + 1800;	#チェックコードの期限
		$rport = $ENV{'REMOTE_PORT'};$himicode .= "?$ENV{'REMOTE_PORT'}";
		@main_code = $limit_time . "&" . $rport;
		print "Checkcode↓<br>\n";
		print "<input type=\"text\" size=8 name=\"himicode\">\n<input type=\"hidden\" name=\"maincode\" value=\"@main_code\">\n";
		print "&nbsp;<img src=\"$himicode\" algin=\"bottom\"><br>\n";
		print "↑画像の数字をCheckcode欄に書き写して投稿してね。\n";
		#ひみこーどここまで
print <<"EOM";
<br>
<input type="submit" value="送信">&nbsp;&nbsp;<input type="reset" value="リセット"><br>
<br>
EOM
		#ログ表示
		print "<hr>\n";
		if(!open(IN, "$logfile")){print "<p align=\"center\"><font color=\"red\">File error</font></p>";};
		@xx = <IN>;
		@xx = reverse (@xx);	#ログの逆順処理
		foreach $line ( @xx )	{
			($no,$res,$name,$subject,$hp,$mail,$comment,$pass,$host,$now,$dmy,$dmy,$icon) = split(/,/,$line);
			$new = 'false';
			if ($res > 0) { $new = 'true'; }
			if ($new eq 'false') { push(@NEW,$line); }
		}
		if ($FORM{'pline'} eq '') { $pline = 0; } else { $pline = $FORM{'pline'}; }
		$end_data = @NEW - 1;
		$page_end = $pline + ($kiji - 1);
		if ($page_end >= $end_data) { $page_end = $end_data; }
		foreach ($pline .. $page_end) {
			($no,$res,$name,$subject,$hp,$mail,$comment,$pass,$host,$now,$dmy,$dmy,$icon) = split(/\,/,$NEW[$_]);
			$comment =~ s/([^=^\"]|^)(http|ftp)([\w|\!\#\&\=\-\%\@\~\;\+\:\.\?\/]+)/$1<a href=\"$2$3\" target=\"_blank\">$2$3<\/a>/g;
			$comment =~ s/&gt;&gt;([0-9]+)/<a href=\"$script?action=view&no=$1\" target=\"_blank\">&gt;&gt;$1<\/a>/g;
			print "No.$no...";
			if($hp =~ /http:\/\/|ftp:\/\/|https:\/\//){
				print "<a href=\"$hp\">HOME</a><br>";
			}elsif($hp =~ /none/){
				print "HOME";
			}
			print "...";
			print "<a href=\"$script?action=resform&res=$no\">返信</a><br>$subject<br>";
			if($mail =~ /([^\x81-\xFF\s\"\'\(\)\<\>\\\`\[\{\]\}\|]+)\@([^\x81-\xFF\s\"\'\(\)\<\>\\\`\[\{\]\}\|]+)\.([^\x81-\xFF\s\"\'\(\)\<\>\\\`\[\{\]\}\|]+)/){
				print "名前：<a href=\"mailtp:$mail\">$name</a>";
			}elsif($mail =~ /none/){
				print "名前：$name";
			}
			print "<br>\n";
			if ( !($icon) )	{	$icon = 0 ;	}
			if ( $icon_gif_w[$icon] != 0 ) { $dmy = "width=\"$icon_gif_w[$icon]\" height=\"$icon_gif_h[$icon]\"" ; } else { $dmy = "" ; }
			print "<img src=\"$icon_gif[$icon]\" $dmy border=0>";
			print "$comment<br><br>";
			if($hostname eq "1"){print "$host<br>";}
			print "$now\n";
			print "<br>\n<br>\n";
			#レス表示
			@xx = sort { $a <=> $b } @xx;	#記事のソート
			foreach $resline (@xx) {
			($no2,$res2,$name2,$subject2,$hp2,$mail2,$comment2,$pass2,$host2,$now2,$dmy2,$dmy2,$icon2) = split(/\,/,$resline);
				$comment2 =~ s/([^=^\"]|^)(http|ftp)([\w|\!\#\&\=\-\%\@\~\;\+\:\.\?\/]+)/$1<a href=\"$2$3\" target=\"_blank\">$2$3<\/a>/g;
				$comment2 =~ s/&gt;&gt;([0-9]+)/<a href=\"$script?action=view&no=$1\" target=\"_blank\">&gt;&gt;$1<\/a>/g;
				if ($no eq $res2) {
					print "No.$no2";
					print "...";
					if($hp2 =~ /http:\/\/|ftp:\/\/|https:\/\//){
						print "<a href=\"$hp2\" target=\"_blank\">HOME</a><br>";
					}elsif($hp2 =~ /none/){
						print "HOME";
					}
					print "<br>\n";
					if($mail2 =~ /([^\x81-\xFF\s\"\'\(\)\<\>\\\`\[\{\]\}\|]+)\@([^\x81-\xFF\s\"\'\(\)\<\>\\\`\[\{\]\}\|]+)\.([^\x81-\xFF\s\"\'\(\)\<\>\\\`\[\{\]\}\|]+)/){
						print "名前：<a href=\"mailto:$mail2\">$name2</a>";
					}elsif($mail2 =~ /none/){
						print "名前：$name2";
					}
					print "<br>\n";
					if ( !($icon2) )	{	$icon2 = 0 ;	}
					if ( $icon_gif_w[$icon2] != 0 ) { $dmy = "width=\"$icon_gif_w[$icon2]\" height=\"$icon_gif_h[$icon2]\"" ; } else { $dmy = "" ; }
					print "<img src=\"$icon_gif[$icon2]\" $dmy border=0>";
					print "$comment2<br>\n<br>\n";
					if($hostname eq "1"){print "$host2<br>";}
					print "$now2<br>";
				}
			}
			print "<hr>";
		}
	}else{
		#PC表示
print <<"EOM";
<table border="1" align="center">
<form action="$script" method="post">
<input type="hidden" name="action" value="regist">
EOM
		print "<tr><TD><CENTER>名前</CENTER></td><TD><INPUT TYPE=\"TEXT\" NAME=\"name\" SIZE=\"30\" MAXLENGTH=\"70\" value=\"";
		foreach (split(/;/, $ENV{'HTTP_COOKIE'})) {
			($name, $value) = split(/=/);
			$name =~ s/\s//g;
			$value =~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("C", hex($1))/eg;
			$cookie{$name} = $value;
		}
		print "$cookie{'name'}";
		print "\"></td></tr>\n";
print <<"EOM";
<tr><TD><CENTER>タイトル</CENTER></td><TD><INPUT TYPE=TEXT NAME="subject" SIZE="30" MAXLENGTH="70" value="$subject"></td></tr>
<tr><TD><CENTER>ホームページ</CENTER></td><TD>
EOM
		if($hp =~ /none/){
			print "<input type=text name=\"hp\" SIZE=\"30\" MAXLENGTH=\"70\" value=\"\">";
		}else{
			print "<input type=text name=\"hp\" SIZE=\"30\" MAXLENGTH=\"70\" value=\"$hp\">";
		}
print <<"EOM";
</td></tr>
<tr><TD><CENTER>メール</CENTER></td><TD>
EOM
		if($mail =~ /none/){
			print "<INPUT TYPE=TEXT NAME=\"mail\" SIZE=\"30\" MAXLENGTH=\"70\" value=\"\">";
		}else{
			print "<INPUT TYPE=TEXT NAME=\"mail\" SIZE=\"30\" MAXLENGTH=\"70\" value=\"$mail\">";
		}
print <<"EOM";
</td></tr>
<tr><TD><CENTER>コメント</CENTER></td><TD><TEXTAREA NAME="comment" ROWS="7" COLS="45">$comment</TEXTAREA>$cerror</td></tr>
<tr><td align="center">アイコン</td><td><select name="icon">
EOM
		$i = 0 ;
		for ( @iconnm ) {
			if ( $i == $c_icon )	{	$dmy = "selected";	}	else	{	$dmy = "" ;	} 
			print "<option value=$i $dmy>$iconnm[$i]\n";
			$i++ ;
		}
		print "</select><a href=\"$script?action=icondisp\">アイコン一覧</a></td></tr>\n";
		print "<tr><td align=\"center\">パスワード</td><td><input type=\"password\" name=\"pass\"></td></tr>\n";
		#ひみこーど表示
		$limit_time = time + 1800;	#チェックコードの期限
		$rport = $ENV{'REMOTE_PORT'};$himicode .= "?$ENV{'REMOTE_PORT'}";
		@main_code = $limit_time . "&" . $rport;
		print "<tr><td align=\"left\">Checkcode</td>\n";
		print "<td><input type=\"text\" size=8 name=\"himicode\">\n<input type=\"hidden\" name=\"maincode\" value=\"@main_code\">\n";
		print "&nbsp;<img src=\"$himicode\" algin=\"bottom\"></td></tr>\n";
		print "<tr><td colspan=\"2\">画像の数字をCheckcode欄に書き写して投稿してね。</td></tr>\n";
print <<"EOM";
<tr><td colspan="2" align="center"><input type="submit" value="送信">&nbsp;&nbsp;<input type="reset" name="reset" value="リセット"></td></tr>
</form>
</table><br>
EOM
		#ログ表示
		print "<hr width=\"500\">";
		if(!open(IN, "$logfile")){print "<br><p align=\"center\"><font color=\"red\">File error</font></p>";};
		@xx = <IN>;
		@xx = reverse (@xx);	#ログの逆順処理
		foreach $line ( @xx )	{
			($no,$res,$name,$subject,$hp,$mail,$comment,$pass,$host,$now,$dmy,$dmy,$icon) = split(/,/,$line);
			$new = 'false';
			if ($res > 0) { $new = 'true'; }
			if ($new eq 'false') { push(@NEW,$line); }
		}
		if ($FORM{'pline'} eq '') { $pline = 0; } else { $pline = $FORM{'pline'}; }
		$end_data = @NEW - 1;
		$page_end = $pline + ($kiji - 1);
		if ($page_end >= $end_data) { $page_end = $end_data; }
		foreach ($pline .. $page_end) {
			($no,$res,$name,$subject,$hp,$mail,$comment,$pass,$host,$now,$dmy,$dmy,$icon) = split(/\,/,$NEW[$_]);
			$comment =~ s/([^=^\"]|^)(http|ftp)([\w|\!\#\&\=\-\%\@\~\;\+\:\.\?\/]+)/$1<a href=\"$2$3\" target=\"_blank\">$2$3<\/a>/g;
			$comment =~ s/&gt;&gt;([0-9]+)/<a href=\"$script?action=view&no=$1\" target=\"_blank\">&gt;&gt;$1<\/a>/g;
			print "<table align=\"center\" width=\"500\">\n";
			print "<tr><td colspan=\"2\">No.$no...$subject...";
			if($hp =~ /http:\/\/|ftp:\/\/|https:\/\//){
				print "<a href=\"$hp\" target=\"_blank\">HOME</a>";
			}elsif($hp =~ /none/){
				print "none";
			}
			print "...";
			print "<a href=\"$script?action=resform&res=$no\">返信</a><br>";
			if($mail =~ /([^\x81-\xFF\s\"\'\(\)\<\>\\\`\[\{\]\}\|]+)\@([^\x81-\xFF\s\"\'\(\)\<\>\\\`\[\{\]\}\|]+)\.([^\x81-\xFF\s\"\'\(\)\<\>\\\`\[\{\]\}\|]+)/){
				print "名前：<a href=\"mailto:$mail\">$name</a>";
			}elsif($mail =~ /none/){
				print "名前：$name";
			}
			
			print "</td></tr>\n";
			print "<tr><td width=\"60\">";
			if ( !($icon) )	{	$icon = 0 ;	}
			if ( $icon_gif_w[$icon] != 0 ) { $dmy = "width=\"$icon_gif_w[$icon]\" height=\"$icon_gif_h[$icon]\"" ; } else { $dmy = "" ; }
			print "<img src=\"$icon_gif[$icon]\" $dmy border=0>";
			print "</td><td>$comment</td></tr>\n";
			print "<tr><td colspan=\"2\"><div align=\"right\">";
			if($hostname eq "1"){print "$host<br>";}
			print "$now</div></td></tr>";
			#レス表示
			@xx = sort { $a <=> $b } @xx;	#記事のソート
			foreach $resline (@xx) {
				($no2,$res2,$name2,$subject2,$hp2,$mail2,$comment2,$pass2,$host2,$now2,$dmy2,$dmy2,$icon2) = split(/\,/,$resline);
				$comment2 =~ s/([^=^\"]|^)(http|ftp)([\w|\!\#\&\=\-\%\@\~\;\+\:\.\?\/]+)/$1<a href=\"$2$3\" target=\"_blank\">$2$3<\/a>/g;
				$comment2 =~ s/&gt;&gt;([0-9]+)/<a href=\"$script?action=view&no=$1\" target=\"_blank\">&gt;&gt;$1<\/a>/g;
				if ($no eq $res2) {
					print "<tr><td colspan=\"2\">No.$no2";
					print "...";
					if($hp2 =~ /http:\/\/|ftp:\/\/|https:\/\//){
						print "<a href=\"$hp2\" target=\"_blank\">HOME</a>";
					}elsif($hp2 =~ /none/){
						print "none";
					}
					print "<br>";
					if($mail2 =~ /([^\x81-\xFF\s\"\'\(\)\<\>\\\`\[\{\]\}\|]+)\@([^\x81-\xFF\s\"\'\(\)\<\>\\\`\[\{\]\}\|]+)\.([^\x81-\xFF\s\"\'\(\)\<\>\\\`\[\{\]\}\|]+)/){
						print "名前：<a href=\"mailto:$mail2\">$name2</a>";
					}elsif($mail2 =~ /none/){
						print "名前：$name2";
					}
					print "</td></tr>\n";
					print "<tr><td width=\"60\">";
					if ( !($icon2) )	{	$icon2 = 0 ;	}
					if ( $icon_gif_w[$icon2] != 0 ) { $dmy = "width=\"$icon_gif_w[$icon2]\" height=\"$icon_gif_h[$icon2]\"" ; } else { $dmy = "" ; }
					print "<img src=\"$icon_gif[$icon2]\" $dmy border=0>";
					print "</td><td>$comment2</td></tr>\n";
					print "<tr><td colspan=\"2\"><div align=\"right\">";
					if($hostname eq "1"){print "$host2<br>";}
					print "$now2</div></td></tr>";
				}
			}
			close(IN);
			print "</table>\n<hr width=\"500\">\n";
		}
	}
	$next_line = $page_end + 1;
	if ($page_end != $end_data) {
		print "<center>\n";
		print "<a href=\"$script?pline=$next_line\">次のページへ</a>\n";
		print "</center>";
	}
	print <<"EOM";
<form action="$script" method="post">
<input type="hidden" name="action" value="delete">
<table align="right" border="0">
<tr><td>番号<input type="text" name="code"></td><td>パスワード<input type="password" name="pass"></td></tr>
<tr><td colspan="2"><input type="submit" value="削除"></td></tr>
</table>
</form>
EOM
	print "<br>\n<br>\n<p align=\"right\"><a href=\"http://download.daisykatsura.net/\" target=\"_blank\">Script by ヒナギク</a><br>\n<a href=\"http://aji.s1.xrea.com/\" target=\"_blank\">checkcode script by -Force 264-v3.22A</a></p>\n";
}

sub footer {
print <<"EOM";
<hr>
<center>
<a href="http://isweb.www.daisykatsura.net/" target="_top">無料HPならisweb</a><br>
Copyright daisykatsura
</center>
$footer
</body>
</html>
EOM
exit;

}

sub get_now {

#日時の取得
	($sec,$min,$hour,$mday,$mon,$year,$wday) = localtime();
	
#日時の調整
	$mon++;#月数には1を足す。
	$year = 1900+$year;#年数には、1900を足す。
	$mon = sprintf("%.2d",$mon);#2桁表示に統一する。
	$mday = sprintf("%.2d",$mday);
	$hour = sprintf("%.2d",$hour);
	$sec = sprintf("%.2d",$sec);
	$min = sprintf("%.2d",$min);
	
	#曜日の日本語化
	@week = ('日','月','火','水','木','金','土');
	$wday = $week[$wday];
	
	#フォーマット指定 例　2003/03/15(土) 20:12:12
	$r = "$year/$mon/$mday($wday) $hour:$min:$sec";
	
	return $r;

}

sub host {
	$host = $ENV{'REMOTE_HOST'};
	$addr = $ENV{'REMOTE_ADDR'};
	if ($host eq "" || $host eq "$addr") {
		($p1,$p2,$p3,$p4) = split(/\./,$addr);
		$temp = pack("C4",$p1,$p2,$p3,$p4);
		$host = gethostbyaddr("$temp", 2);
		if ($host eq "") { $host = $addr; }
	}
}

sub check {
	$host = gethostbyaddr(pack("C4", split(/\./, $ENV{'REMOTE_ADDR'})), 2) || $ENV{'REMOTE_ADDR'};
	
	foreach $i (@hosts) {
		if ($host =~ /$i/) {
			print "<div align=\"center\">書き込み出来ませんでした。<br><a href=\"$script\">戻る</a></div>\n";
			&footer;
		}
	}
}

sub regist {
	if($proxy == 1){
		unless($agent =~ /UP.Browser|DoCoMo|J-PHONE|Vodafone|SoftBank/){
			if($ENV{'HTTP_VIA'}||$ENV{'HTTP_FORWARDED'}||$ENV{'HTTP_PROXY_CONNECTION'}||$ENV{'HTTP_CACHE_INFO'}||$ENV{'HTTP_XROXY_CONNECTION'}||$ENV{'HTTP_XONNECTION'}||$ENV{'HTTP_X_FORWARDED_FOR'}){
				&header;
				print "Proxy規制中";
				&footer;
			}
		}
	}
	
	#ひみこーど処理
	$time = time;
	if ( $himicode_ck == 1 ) { 
		if ( $FORM{'himicode'} eq "" ) { &header;print "<center>Checkcodeを入力して下さい</center>";&footer;}
		if ( $FORM{'himicode'} !~ /\d/ ) { &header;print "<center>Checkcodeは半角数字で入力して下さい。または数字以外の文字が入っています</center>";&footer;}
		foreach ( $FORM{'maincode'} ) { ( $get_limittime , $get_rport ) = split(/&/,$_); }
		if ( $get_limittime < $time ) { &header;print "<center>Checkcodeが古くなってしまいました。一度リロードしてから投稿して下さい</center>";&footer;
		}else {
			if ( !open ( CODE , "$codefile" ) ) { &header;print "<center>コードファイルの読み込みに失敗しました</center>";&footer; 
			}else{ @code_log = <CODE>;close(CODE);$machi_code = $FORM{'himicode'} . $get_rport;
				foreach ( @code_log ) { chop($_);if ( $machi_code eq $_ ) { &header;print "<center>このCheckcodeはすでに使用されています。一度リロードしてから投稿して下さい</center>";&footer; } } 
			}
			if ( !open ( HIMI , "$himicode_log" ) ) { &header;print "<center>ひみこーどログファイルのオープンに失敗しました</center>";&footer; 
			}else { @himicode_log = <HIMI>;close(HIMI);$code_f = 0;
				foreach ( @himicode_log ) { chop($_);if ( $machi_code eq $_ ) { $code_f = 1;last; } }
				if ( $code_f != 1 ) { &header;print "<center>Checkcodeが違います</center>";&footer; }
			}
		}
	}
	
	$now=&get_now;
	&host;
	&check;
	$namae = "$FORM{'name'}";
	$subject = "$FORM{'subject'}";
	$hp = "$FORM{'hp'}";
	$mail = "$FORM{'mail'}";
	$comment = "$FORM{'comment'}";
	$icon = "$FORM{'icon'}";
	$pass = "$FORM{'pass'}";
	#危険なタグ禁止！
	if ($tag eq 'yes') {
		foreach ( @errtag )	{
			if ($comment =~ /<$_(.|\n)*>/i) {	 &header;print "<center>使用出来ないタグが含まれてます</center>";&footer;	}
		}
	}	else	{
		$comment =~ s/</&lt;/g;
		$comment =~ s/>/&gt;/g;
	}
	
	if(!$namae){$namae = "匿名";}
	if(!$subject){$subject = "&lt;no subject&gt;";}
	if(!$hp){$hp = "none";}
	if(!$mail){$mail = "none";}
	if(!$comment){
		$cerror = "<br><font color=\"red\">↑コメントがありません</font>";
		&header;
		&body;
		&footer;
	}
	
	&trip;
	&trip_hozon;
	
	$no = 1;
	open(IN, "$logfile");
	@xx = <IN>;
	foreach ( @xx )	{
		($no) = split(/,/,$_);
		$no++;
	}
	open(OUT, ">> $logfile");
	flock(OUT, LOCK_EX);	#ファイルロック
	print OUT "$no,$res,$namae,$subject,$hp,$mail,$comment,$pass,$host,$now,$dmy,$dmy,$icon\n";
	close(OUT);
	close(IN);
	
	$namae =~ s/(\W)/sprintf("%%%02X", unpack("C", $1))/eg;
	print "Set-Cookie: name=$namae; expires=Wed, 31-Dec-2030 23:59:59 GMT\n";	
	&header;
	print "<center>書き込みました。<br><a href=\"$script\">戻る</a></center>";
	&footer;
}

sub resform {
	&header;
	print "<a href=\"$script\">戻る</a><br>\n";
	#ログ表示
	if(!open(IN, "$logfile")){print "<br><p align=\"center\"><font color=\"red\">File error</font></p>";};
	@xx = <IN>;
	foreach $line ( @xx )	{
		($no,$res,$name,$subject,$hp,$mail,$comment,$pass,$host,$now,$dmy,$dmy,$icon) = split(/,/,$line);
		$comment =~ s/([^=^\"]|^)(http|ftp)([\w|\!\#\&\=\-\%\@\~\;\+\:\.\?\/]+)/$1<a href=\"$2$3\" target=\"_blank\">$2$3<\/a>/g;
		if($no eq $FORM{'res'}){
			print "<table align=\"center\" width=\"500\">\n";
			print "<tr><td colspan=\"2\">No.$no...$subject...";
			if($hp =~ /http:\/\/|ftp:\/\/|https:\/\//){
				print "<a href=\"$hp\" target=\"_blank\">HOME</a>";
			}elsif($hp =~ /none/){
				print "none";
			}
			print "<br>";
			if($mail =~ /([^\x81-\xFF\s\"\'\(\)\<\>\\\`\[\{\]\}\|]+)\@([^\x81-\xFF\s\"\'\(\)\<\>\\\`\[\{\]\}\|]+)\.([^\x81-\xFF\s\"\'\(\)\<\>\\\`\[\{\]\}\|]+)/){
				print "名前：<a href=\"mailto:$mail\">$name</a>";
			}elsif($mail =~ /none/){
				print "名前：$name";
			}
			
			print "</td></tr>\n";
			print "<tr><td width=\"60\">";
			if ( !($icon) )	{	$icon = 0 ;	}
			if ( $icon_gif_w[$icon] != 0 ) { $dmy = "width=\"$icon_gif_w[$icon]\" height=\"$icon_gif_h[$icon]\"" ; } else { $dmy = "" ; }
			print "<img src=\"$icon_gif[$icon]\" $dmy border=0>";
			print "</td><td>$comment</td></tr>\n";
			print "<tr><td colspan=\"2\"><div align=\"right\">$host<br>$now</div></td></tr>";
			#レス表示
			foreach $resline (@xx) {
				($no2,$res2,$name2,$subject2,$hp2,$mail2,$comment2,$pass2,$host2,$now2,$dmy2,$dmy2,$icon2) = split(/\,/,$resline);
				$comment2 =~ s/([^=^\"]|^)(http|ftp)([\w|\!\#\&\=\-\%\@\~\;\+\:\.\?\/]+)/$1<a href=\"$2$3\" target=\"_blank\">$2$3<\/a>/g;
				if ($no eq $res2) {
					print "<tr><td colspan=\"2\">No.$no2";
					print "...";
					if($hp2 =~ /http:\/\/|ftp:\/\/|https:\/\//){
						print "<a href=\"$hp2\" target=\"_blank\">HOME</a>";
					}elsif($hp2 =~ /none/){
						print "none";
					}
					print "<br>";
					if($mail2 =~ /([^\x81-\xFF\s\"\'\(\)\<\>\\\`\[\{\]\}\|]+)\@([^\x81-\xFF\s\"\'\(\)\<\>\\\`\[\{\]\}\|]+)\.([^\x81-\xFF\s\"\'\(\)\<\>\\\`\[\{\]\}\|]+)/){
						print "名前：<a href=\"mailto:$mail2\">$name2</a>";
					}elsif($mail2 =~ /none/){
						print "名前：$name2";
					}
					print "</td></tr>\n";
					print "<tr><td width=\"60\">";
					if ( !($icon2) )	{	$icon2 = 0 ;	}
					if ( $icon_gif_w[$icon2] != 0 ) { $dmy = "width=\"$icon_gif_w[$icon2]\" height=\"$icon_gif_h[$icon2]\"" ; } else { $dmy = "" ; }
					print "<img src=\"$icon_gif[$icon2]\" $dmy border=0>";
					print "</td><td>$comment2</td></tr>\n";
					print "<tr><td colspan=\"2\"><div align=\"right\">$host2<br>$now2</div></td></tr>";
				}
			}
		}
		print "</table>";
		close(IN);
	}
	print "<center><font size=\"5\">▼$FORM{'res'}への返信▼</font></center>";
	#ユーザエージェント判別
	#ケータイ
	if($agent =~ /UP.Browser|DoCoMo|J-PHONE|Vodafone|SoftBank/){
	print "<FORM ACTION=\"$script\" METHOD=\"post\">\n";
	print "<input type=\"hidden\" name=\"action\" value=\"resregist\">\n";
	print "<input type=\"hidden\" name=\"res\" value=\"$FORM{'res'}\">\n";
	print "<input type=\"text\" name=\"name\" value=\"";
	foreach (split(/;/, $ENV{'HTTP_COOKIE'})) {
		($name, $value) = split(/=/);
		$name =~ s/\s//g;
		$value =~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("C", hex($1))/eg;
		$cookie{$name} = $value;
	}
	print "$cookie{'name'}";
	print "\"><br>\n";
	print "ホームページ↓<br><input type=text name=\"hp\" value=\"\"><br>\n";
	print "メール↓<br><INPUT TYPE=TEXT NAME=\"mail\" value=\"\"><br>\n";
	print "コメント↓<br><TEXTAREA NAME=\"comment\"></TEXTAREA><br>$cerror<br>\n";
	print "<select name=\"icon\">";
	$i = 0 ;
	for ( @iconnm ) {
		if ( $i == $c_icon )	{	$dmy = "selected";	}	else	{	$dmy = "" ;	} 
		print "<option value=$i $dmy>$iconnm[$i]\n";
		$i++ ;
	}
	print "</select>\n";
	print "<a href=\"$script?action=icondisp\">アイコン一覧</a><br>\n";
	print "パスワード↓<br><input type=\"password\" name=\"pass\"><br>\n";
	#ひみこーど開始
	$limit_time = time + 1800;	#チェックコードの期限
	$rport = $ENV{'REMOTE_PORT'};$himicode .= "?$ENV{'REMOTE_PORT'}";
	@main_code = $limit_time . "&" . $rport;
	print "Checkcode↓<br>\n";
	print "<input type=\"text\" size=8 name=\"himicode\">\n<input type=\"hidden\" name=\"maincode\" value=\"@main_code\">\n";
	print "&nbsp;<img src=\"$himicode\" algin=\"bottom\"><br>\n";
	print "↑画像の数字をCheckcode欄に書き写して投稿してね。\n";
	#ひみこーどここまで
	print "<input type=\"submit\" value=\"送信\">&nbsp;&nbsp;<input type=\"reset\" name=\"reset\" value=\"リセット\"><br>\n";
	print "</form>\n";
	}else{
	#パソコン
	print "<table border=\"1\" align=\"center\">\n";
	print "<FORM ACTION=\"$script\" METHOD=\"post\">\n";
	print "<input type=\"hidden\" name=\"action\" value=\"resregist\">\n";
	print "<input type=\"hidden\" name=\"res\" value=\"$FORM{'res'}\">\n";
	print "<tr><TD><CENTER>名前</CENTER></td><TD><INPUT TYPE=\"TEXT\" NAME=\"name\" SIZE=\"30\" MAXLENGTH=\"70\" value=\"";
	foreach (split(/;/, $ENV{'HTTP_COOKIE'})) {
		($name, $value) = split(/=/);
		$name =~ s/\s//g;
		$value =~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("C", hex($1))/eg;
		$cookie{$name} = $value;
	}
	print "$cookie{'name'}";
	print "\"></td></tr>\n";
	print "<tr><TD><CENTER>ホームページ</CENTER></td><TD><input type=text name=\"hp\" SIZE=\"30\" MAXLENGTH=\"70\" value=\"\"></td></tr>\n";
	print "<tr><TD><CENTER>メール</CENTER></td><TD><INPUT TYPE=TEXT NAME=\"mail\" SIZE=\"30\" MAXLENGTH=\"70\" value=\"\"></td></tr>\n";
	print "<tr><TD><CENTER>コメント</CENTER></td><TD><TEXTAREA NAME=\"comment\" ROWS=\"7\" COLS=\"45\"></TEXTAREA>$cerror</td></tr>\n";
	print "<tr><td align=\"center\">アイコン</td><td><select name=\"icon\">";
	$i = 0 ;
	for ( @iconnm ) {
		if ( $i == $c_icon )	{	$dmy = "selected";	}	else	{	$dmy = "" ;	} 
		print "<option value=$i $dmy>$iconnm[$i]\n";
		$i++ ;
	}
	print "</select></td></tr>\n";
	print "<tr><td align=\"center\">パスワード</td><td><input type=\"password\" name=\"pass\"></td></tr>\n";
	#ひみこーど表示
	$limit_time = time + 1800;	#チェックコードの期限
	$rport = $ENV{'REMOTE_PORT'};$himicode .= "?$ENV{'REMOTE_PORT'}";
	@main_code = $limit_time . "&" . $rport;
	print "<tr><td align=\"left\">Checkcode</td>\n";
	print "<td><input type=\"text\" size=8 name=\"himicode\">\n<input type=\"hidden\" name=\"maincode\" value=\"@main_code\">\n";
	print "&nbsp;<img src=\"$himicode\" algin=\"bottom\"></td></tr>\n";
	print "<tr><td colspan=\"2\">画像の数字をCheckcode欄に書き写して投稿してね。</td></tr>\n";
	print "<tr><td colspan=\"2\" align=\"center\"><input type=\"submit\" value=\"送信\">&nbsp;&nbsp;<input type=\"reset\" name=\"reset\" value=\"リセット\"></td></tr>\n";
	print "</form>\n</table>\n";
	}
	print "<a href=\"$script\">戻る</a><br>\n";
	&footer;
}

sub resregist {
	if($proxy == 1){
		unless($agent =~ /UP.Browser|DoCoMo|J-PHONE|Vodafone|SoftBank/){
			if($ENV{'HTTP_VIA'}||$ENV{'HTTP_FORWARDED'}||$ENV{'HTTP_PROXY_CONNECTION'}||$ENV{'HTTP_CACHE_INFO'}||$ENV{'HTTP_XROXY_CONNECTION'}||$ENV{'HTTP_XONNECTION'}||$ENV{'HTTP_X_FORWARDED_FOR'}){
				&header;
				print "Proxy規制中";
				&footer;
			}
		}
	}
	
	$time = time;
	#ひみこーど処理
	if ( $himicode_ck == 1 ) { 
		if ( $FORM{'himicode'} eq "" ) { &header;print "<center>Checkcodeを入力して下さい</center>";&footer;}
		if ( $FORM{'himicode'} !~ /\d/ ) { &header;print "<center>Checkcodeは半角数字で入力して下さい。または数字以外の文字が入っています</center>";&footer;}
		foreach ( $FORM{'maincode'} ) { ( $get_limittime , $get_rport ) = split(/&/,$_); }
		if ( $get_limittime < $time ) { &header;print "<center>Checkcodeが古くなってしまいました。一度リロードしてから投稿して下さい</center>";&footer;
		}else {
			if ( !open ( CODE , "$codefile" ) ) { &header;print "<center>コードファイルの読み込みに失敗しました</center>";&footer; 
			}else{ @code_log = <CODE>;close(CODE);$machi_code = $FORM{'himicode'} . $get_rport;
				foreach ( @code_log ) { chop($_);if ( $machi_code eq $_ ) { &header;print "<center>このCheckcodeはすでに使用されています。一度リロードしてから投稿して下さい</center>";&footer; } } 
			}
			if ( !open ( HIMI , "$himicode_log" ) ) { &header;print "<center>ひみこーどログファイルのオープンに失敗しました</center>";&footer; 
			}else { @himicode_log = <HIMI>;close(HIMI);$code_f = 0;
				foreach ( @himicode_log ) { chop($_);if ( $machi_code eq $_ ) { $code_f = 1;last; } }
				if ( $code_f != 1 ) { &header;print "<center>Checkcodeが違います</center>";&footer; }
			}
		}
	}
	
	
	$now=&get_now;
	&host;
	&check;
	$res = "$FORM{'res'}";
	$namae = "$FORM{'name'}";
	$hp = "$FORM{'hp'}";
	$mail = "$FORM{'mail'}";
	$comment = "$FORM{'comment'}";
	$icon = "$FORM{'icon'}";
	$pass = "$FORM{'pass'}";
	
	#危険なタグ禁止！
	if ($tag eq 'yes') {
		foreach ( @errtag )	{
			if ($comment =~ /<$_(.|\n)*>/i) {	 &header;print "<center>使用出来ないタグが含まれてます</center>";&footer;	}
		}
	}	else	{
		$comment =~ s/</&lt;/g;
		$comment =~ s/>/&gt;/g;
	}
	
	if(!$namae){$namae = "匿名";}
	if(!$hp){$hp = "none";}
	if(!$mail){$mail = "none";}
	if(!$comment){
		$cerror = "<br>\n<font color=\"red\">↑コメントがありません</font>";
		&resform;
	}
	
	&trip;
	&trip_hozon;
	
	#ログファイル読み込み
	open(IN, "$logfile");
	@xx = <IN>;
	foreach ( @xx ){
		($no,$resno,$name2,$subject2,$hp2,$mail2,$comment2,$pass2,$host2,$now2,$dmy2,$dmy2,$icon2) = split(/,/,$_);
		if($no eq $res){$oya=$_; }else{push(@xx2,$_);}
		$no++;
	}
	push(@xx2,$oya);
	push(@xx2,"$no,$res,$namae,$subject,$hp,$mail,$comment,$pass,$host,$now,$dmy,$dmy,$icon\n");
	#ログファイル書き込み
	open(OUT, "> $logfile");
	flock(OUT, LOCK_EX);	#ファイルロック
	print OUT @xx2;
	close(IN);
	close(OUT);	
	
	
	$namae =~ s/(\W)/sprintf("%%%02X", unpack("C", $1))/eg;
	print "Set-Cookie: name=$namae; expires=Wed, 31-Dec-2030 23:59:59 GMT\n";
	&header;
	print "<center>書き込みました。<br>\n<a href=\"./$script\">戻る</a></center>\n";
	&footer;
}

sub view {
	&header;
	if(!open(IN, "$logfile")){print "<br><p align=\"center\"><font color=\"red\">File error</font></p>";};
	@xx = <IN>;
	foreach $line ( @xx )	{
		
		($no,$res,$name,$subject,$hp,$mail,$comment,$pass,$host,$now,$dmy,$dmy,$icon) = split(/,/,$line);
		$comment =~ s/([^=^\"]|^)(http|ftp)([\w|\!\#\&\=\-\%\@\~\;\+\:\.\?\/]+)/$1<a href=\"$2$3\" target=\"_blank\">$2$3<\/a>/g;
		$comment =~ s/&gt;&gt;([0-9]+)/<a href=\"$script?action=view&no=$1\">&gt;&gt;$1<\/a>/g;
		if($FORM{'no'} eq "$no"){
			print "<table align=\"center\" width=\"500\">";
			print "<tr><td colspan=\"2\">No.$no...$subject";
			print "...";
			print "<a href=\"$hp\">HOME</a><br>\n";
			print "名前：";
			if($mail =~ /([^\x81-\xFF\s\"\'\(\)\<\>\\\`\[\{\]\}\|]+)\@([^\x81-\xFF\s\"\'\(\)\<\>\\\`\[\{\]\}\|]+)\.([^\x81-\xFF\s\"\'\(\)\<\>\\\`\[\{\]\}\|]+)/){
				print "<a href=\"mailto:$mail\">$name</a>";
			}elsif($mail =~ /none/){
				print "$name";
			}
			print "</td></tr>";
			print "<tr><td width=\"60\">";
			if ( !($icon) )	{	$icon = 0 ;	}
			if ( $icon_gif_w[$icon] != 0 ) { $dmy = "width=\"$icon_gif_w[$icon]\" height=\"$icon_gif_h[$icon]\"" ; } else { $dmy = "" ; }
			print "<img src=\"$icon_gif[$icon]\" $dmy border=0>";

			print "</td><td>$comment</td></tr>";
			print "<tr><td colspan=\"2\"><div align=\"right\">$host</div></td></tr>";
			print "</table>";
		}
		close(IN);
	}
	&footer;
}

sub icondisp {
	&header ;															#<<<htmlヘッダー出力
	print "[<a href=$script>BACK</a>]\n";	#i010204
	print "<center><br><br>■■■ アイコン一覧 ■■■<br><br>\n";
	print "<table cellpadding=5 cellspacing=0 border=0>\n";
	$i = 0 ; $j = 0 ;
	while ( 1 )	{
		print "<tr>\n";
		for ( $ln = 1 ; $j <= $#icon_gif && $ln <= $icon_line ; ) {
			print "<td align=\"center\"><img src=\"$icon_gif[$j]\" border=0></td>\n";
			print "<td align=\"center\">$iconnm[$j]</td>\n";
			$j++ ; $ln++ ;
		}
		if ( $j > $#icon_gif ) { 
			if ( $ln < $icon_line ) {
				for ( ; $ln <= $icon_line ; ) {
					print "<td align=\"center\">&nbsp;</td>\n";
					print "<td align=\"center\">&nbsp;</td>\n";
					$ln++ ;
				}
			}
			print "</tr>\n";
			last ;
		}
		print "</tr>\n";
		$i++;
	}
	print "</table>";
	&footer;
}

sub delete {
	
	if($FORM{'pass'} eq ""){&header;print "パスワードが入力されていません";&footer;}
	
	if(!$FORM{'code'}){&header;print "記事ナンバーが入力されてません";&footer;}elsif($FORM{'code'} < 1){&header;print "記事ナンバーが不正です";&footer;}
	
	if (!open(NOTE,"$logfile")) { &header;print "<center>ファイルが開けません</center>";&footer; }
	@DATA = <NOTE>;
	close(NOTE);
	$i = 0; $match = 0;
	foreach $line (@DATA) {
		($no,$res,$name,$subject,$hp,$mail,$comment,$pass,$host,$now,$dmy,$dmy,$icon) = split(/\,/,$line);
		if($FORM{'code'} == $no){
			if($FORM{'pass'} eq "$pass" || $FORM{'pass'} eq "$password"){
				splice(@DATA,$i,1);
				$match = 1; last;
			}
		}
		$i++;
	}
	
	if ($match) {
		if (!open(NOTE,">$logfile")){&header;print "<center>ファイルが開けません</center>";&footer;}
		print NOTE @DATA;
		close(NOTE);
	}
	
	
	&header;
	
	print "<center>\n削除しました<br>\n<a href=\"$script\">戻る</a>\n</center>\n";
	
	&footer;
}

#トリップの処理
sub trip {
	$namae =~ s/&#9670;/◆/g;
	if ( $namae =~ /◆/ ) {
		if ( $pass eq "" ) {
			&header;
			print "<center>トリップ付きの名前を使用する場合はパスワードを入力して下さい。</center>\n";
			&footer;
		}else { &pass_enc($pass);$namae =~ s/\s|◆|　//g;$namae = "◆" . $namae;$trip_name = $namae . "&" . $pass;
			if ( !open ( T_NAME , "$tripfile" ) ) {
				&header;
				print "<center>TripNameファイルのオープンに失敗しました。</center>\n";
				&footer;
			}else { @trip_name_log = <T_NAME>;close(T_NAME);$name_f = 0;
				foreach ( @trip_name_log ) {  ( $log_name , $log_pass ) = split(/&/,$_);chop($log_pass);
					if ( $namae eq $log_name && $pass ne $log_pass ) { 
						&header;
						print "<center>入力したパスワードが一致しませんでした。</center>\n";
						&footer; }
					if ( $namae eq $log_name && $pass eq $log_pass ) { $name_f = 1;last; }	#保存処理の判別用
				}
			}
		}							
	}
}
#トリップ付きの名前を保存
sub trip_hozon {
	if ( $namae =~ /◆/ ) { &filelock;
		if ( !open (T_NAME, ">$tripfile") ) {
			&fileunlock;
			&header;
			print "TripNameファイルの書き込みに失敗しました";
			&footer; 
		}else{ 
			if ( $name_f == 1 ) {	#保存済みのトリップ付きの名前が使われたら一番上に上げる
				foreach ( @trip_name_log ) { chop($_);
					if ( $trip_name eq $_ ) { $_ = ""; } 
					else{$_ = $_ . "\n";push ( @newtrip_name_log , $_ );}
				}unshift(@newtrip_name_log , "$trip_name\n" );@newtrip_name_log = @newtrip_name_log[0..$trip_logmax - 1];print T_NAME @newtrip_name_log;close(T_NAME);&fileunlock;
			}else{unshift(@trip_name_log , "$trip_name\n" );@trip_name_log = @trip_name_log[0..$trip_logmax - 1];print T_NAME @trip_name_log;close(T_NAME);&fileunlock;} 
		}
	}
}

###<--------------------------------------------------------------
###<---   ファイルロック設定
###<--------------------------------------------------------------
sub filelock {
	if (-e $lockfile) {
		($ftm) = (stat($lockfile))[9];
		if ($ftm < time - 150) { unlink($lockfile); }
	}
	foreach (1 .. 5) {
		if (-e $lockfile) { sleep(1); }
		else {
			open(LOCK,">$lockfile");
			close(LOCK);
			return;
		}
	}
	&header;&error("只今他の方が書き込み中です。ブラウザの「戻る」で戻って再度登録を行って下さい。<br>又は設置時にロックファイル($lockfile)が残ったままかもしれませんので、同ファイルを削除して下さい。");&footer; 
}
###<--------------------------------------------------------------
###<---   ファイルロック解除
###<--------------------------------------------------------------
sub fileunlock {
	if (-e $lockfile) { unlink($lockfile); }
}

###<-------------------------------------------------------------
###<---   パスワード暗号化
###<--------------------------------------------------------------
sub pass_enc {
	if ( $ango == 1 ) {	$pass = crypt($_[0], $_[0]);	}
	else	{	$pass = $_[0];	}
}
###<-------------------------------------------------------------
###<---   パスワードチェック
###<--------------------------------------------------------------
sub pass_dec {
	if ( $ango == 1 ) {
		if ($_[0] ne '' && ( crypt($FORM{'pass'}, $_[0]) eq $_[0]) )  {	return 0 ;	}
	}	else	{	if ($FORM{'pass'} eq $_[0]) {	return 0 ;	}	}
	return 1;
}

exit;
